//
//
//    logic.cpp
//
//

#include <iostream>
#include "logic.h"
#include "ui.h"
#include <fstream>
using namespace std;

Autom createAutom (int id, string mark, string model, int year, string capacity, int seatsNr, double dayPrice)
{
   
    Autom autom;
    autom.id               = id;
    autom.mark             = mark;
    autom.model            = model;
    autom.year             = year;
    autom.capacity         = capacity;
    autom.seatsNr          = seatsNr;
    autom.dayPrice        = dayPrice;
    autom.rentedByCustomer = NULL_ID;
    autom.timesRented      = 0;
    autom.moneyEarned      = 0;
    return autom;
}

Customer createCustomer (int id, string name, int age, int pCode) 
{
    Customer customer;
    customer.id          = id;
    customer.name        = name;
    customer.age         = age;
    customer.pCode       = pCode;
    customer.moneyEarned = 0;
    return customer;
}

bool isAutomRented (const Autom& autom)
{
    return autom.rentedByCustomer != NULL_ID;
}

double rentAutomAndGetMoneyEarned (Autom& autom, Customer& customer, int dayCount)
{
    double moneyEarned = dayCount * autom.dayPrice;
    autom.rentedByCustomer   = customer.id;
    autom.timesRented++;
    autom.moneyEarned       += moneyEarned;
    customer.moneyEarned   += moneyEarned;
    return moneyEarned;
}

void returnBackRentedAutom (Autom& autom)
{
    autom.rentedByCustomer = NULL_ID;
     
}
//----------------------------------------------------------------------
void start     (Automs&  automs, Customers& customers)
{
    int     size;
    ifstream automsfile;
    automsfile.open ("automs.txt");
    automsfile >> size;
    for (int i = 0; i < size; i++)
    {
        string mark, model, copancity;
        int id, year, rentedByCustomer, timesRented;
        automsfile   >> id;
        while (mark.size() <= 0)
            getline(automsfile, mark);
        while (model.size() <= 0)
            getline(automsfile, model);
        automsfile   >> year
		>> copancity
		>> rentedByCustomer
		>> timesRented;
        Autom autom = createAutom(automs.size(), mark, model, year, copancity, rentedByCustomer, timesRented);
        automs.push_back(autom);
    }
    automsfile.close();
	
    ifstream customersfile;
    customersfile.open ("customers.txt");
    customersfile >> size;
    for (int i = 0;  i < size;  i++)
    {
		int           id;
		std::string   name;
		int           age;
		long          pCode;
		double        moneyEarned;
        customersfile   >> id
		>> name;
		Customer customer = createCustomer(customers.size(), mark, model, year, capacity, seatsNr, dayPrice);
		customers.push_back(customer);
    }
    customersfile.close();
}

//----------------------------------------------------------------------
void exit     (const Automs&  automs, const Customers& customers)
{
    ofstream automsfile;
    automsfile.open ("automs.txt");
    automsfile <<  automs.size();
    for (int i = 0;  i < automs.size();  i++)
    {
        Autom autom = automs[i];
        automsfile   << "\n"  << autom.id
		<< "\n"         << autom.mark
		<< "\n"         << autom.model
		<< "\n"         << autom.year
		<< "\n"         << autom.copancity
		<< "\n"         << autom.rentedByCustomer
		<< "\n"         << autom.timesRented;
    }
    automsfile.close();
	
    ofstream customersfile;
    customersfile.open ("customers.txt");
    customersfile <<  customers.size();
    for (int i = 0;  i < customers.size();  i++)
    {
        customersfile   << "\n" << customers[i].id
		<< "\n"    << customers[i].age
		<< "\n"    << customers[i].name
		<< "\n"    << customers[i].pCode
		<< "\n"    << customers[i].moneyEarned;
    }
    customersfile.close();
}


    
    
    
