//
//
//    logic.h
//
//

#ifndef  __logic_h
#define  __logic_h

#include <string>
#include <vector>


const int NULL_ID = -1;

struct Autom
{
    int           id;
    int           seatsNr;
    std::string   capacity; 
    std::string   mark;
    std::string   model;
    int           year;
    double        dayPrice;
    int           rentedByCustomer;
    int           timesRented;
    double        moneyEarned;
};

typedef std::vector<Autom> Automs;

struct Customer
{
    int           id;
    std::string   name;
    int           age;
    long          pCode;
    double        moneyEarned;
};

typedef std::vector<Customer> Customers;

Autom createAutom (int id, std::string mark, std::string model, int year, std::string capacity, int seatsNr, double dayPrice, int rentedByCustomer, int timesRented, int moneyEarned);
Customer createCustomer (int id, std::string name, int age, int pCode, int moneyEarned);

bool   isAutomRented        (const Autom& autom);  
double rentAutomAndGetMoneyEarned (Autom& autom, Customer& customer, int dayCount);
void   returnBackRentedAutom      (Autom& autom);
void start     (Automs&  automs, Customers& customers);
void exit     (const Automs&  automs,const Customers& customers);

#endif
