//
//
//    ui.cpp
//
//

#include <iostream>
#include "ui.h"
#include <fstream> //failai
using namespace std;

static bool exitRequested = false;


//----------------------------------------------------------------------
bool wasExitRequested ()
{
    return exitRequested;
}
//----------------------------------------------------------------------


void printCommandPrompt ()
{
    cout << "\n";
    cout << "-------------------------------------------------------\n";
    cout << "    -------------\n";
    cout << "-------          2010 gruodis             -------------\n";
    cout << "-------       automobiliu nuoma           -------------\n";
    cout << "-------------------------------------------------------\n";
    cout << "Iveskite komanda (m - rodyti meniu): ";
}
//----------------------------------------------------------------------
string inputCommand ()
{
    string command;
    cin >> command;
    return command;
}
//----------------------------------------------------------------------
void printMenu       ();
void addAutom         (Automs&     automs);
void addCustomer     (Customers&  customers);
void rentAutom        (Automs&     automs, Customers& customers);
void returnBackAutom  (Automs&     automs);
void printRented     (Automs&     automs);
void printNotRented  (Automs&     automs);
void moneyEarnedFromCustomer (Customers& customers,Automs& automs);
void mostRented      (Automs&     automs);
void mostEarned      (Automs&     automs);
void readFromFileAutom (Automs&    automs);
//----------------------------------------------------------------------
void processCommand (Automs& automs, Customers& customers, string command)
{
    
         if (command == "0") exitRequested = true;
    else if (command == "m") printMenu       ();
    else if (command == "1") printAutomsAndReturnCount(automs, AUTOM_FILTER_ALL);
    else if (command == "2") printRented     (automs);
    else if (command == "3") printNotRented  (automs);
    else if (command == "4") addAutom         (automs);
    else if (command == "5") rentAutom        (automs, customers);
    else if (command == "6") returnBackAutom  (automs);
    else if (command == "7") printCustomersAndReturnCount(customers);
    else if (command == "8") addCustomer     (customers);
    else if (command == "9") moneyEarnedFromCustomer(customers,automs);
    else if (command =="10") mostRented(automs); 
    else if (command =="11") mostEarned(automs);
    else cout << endl << "Neteisinga komanda." << endl;
}
//----------------------------------------------------------------------
void printAutom (const Autom&  autom)
{
    cout << "id="          << autom.id
         << "\tklientas="  << autom.rentedByCustomer
         << "\t"           << autom.dayPrice << "Lt"
         << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
         << "\t"           << autom.year
         << "\t"           << autom.mark
         << "\t"           << autom.model
         << endl;
}
//----------------------------------------------------------------------
void printCustomer (const Customer& customer)
{
    cout << "id="               << customer.id
         << "\t(uzdirbo   "     << customer.moneyEarned << "Lt)"
         << "\t"                << customer.name
         << " (Asmnes kodas: "  << customer.pCode << ")"
         << endl;
}
//----------------------------------------------------------------------
int printAutomsAndReturnCount (const Automs& automs, AutomFilter automFilter)
{
    int count = 0;
    for (int i = 0;  i < automs.size();  i++)
    {
        Autom autom = automs[i];
        if (automFilter == AUTOM_FILTER_ALL
        || (automFilter == AUTOM_FILTER_RENTED      &&  isAutomRented(autom))
        || (automFilter == AUTOM_FILTER_NOT_RENTED  && !isAutomRented(autom))
           )
        {
            printAutom(autom);
            count += 1;
        }
    }
    if (count == 0)
    {
        switch (automFilter)
        {
            case AUTOM_FILTER_RENTED     : cout << "Isnuomuotu";  break;
            case AUTOM_FILTER_NOT_RENTED : cout << "Laisvu";      break;
            default                     : cout << "Visu";        break;
        }
        cout << " automobiliu sarasas yra tuscias." << endl;
    }
    return count;
}
//----------------------------------------------------------------------
int printCustomersAndReturnCount (const Customers& customers)
{
    for (int i = 0;  i < customers.size();  i++)
        printCustomer( customers[i] );
    int count = customers.size();
    if (count == 0)
        cout << "Klientu sarasas yra tuscias." << endl;
    return count;
}
//----------------------------------------------------------------------
void printMenu ()
{
    cout << endl
         << "  1 - spausdinti automobiliu sarasa"     << endl
         << "  2 - spausdinti isnomuotu automobiliu sarasa" << endl
         << "  3 - spausdinti laisvu automobiliu sarasa"  << endl
         << endl
         << "  4 - prideti nauja automobili"   << endl
         << "  5 - isnuomuoti klientui"   << endl
         << "  6 - automobilio grazinimas"      << endl
         << endl
         << "  7 - spausdinti klientus"   << endl
         << "  8 - prideti nauja klienta" << endl
         << "  9 - isnomuoti automobiliai pagal klienta" << endl
         << endl
         << " 10 - populiariausias automobilis " << endl
         << " 11 - daugiausiai uzdirbes automobilis" << endl
         << endl
         << "  0 - baigti darba"   << endl;
}
//----------------------------------------------------------------------
string readNonEmptyLineFromCin ()
{
    string line = "";
    while (line.size() <= 0)
        getline(cin, line);
    return line;
}
//----------------------------------------------------------------------
void addAutom (Automs& automs)
{  
    string  mark;
    string  model;
    int     year;
    string  capacity;
    int     seatsNr;
    double  dayPrice;
    cout << "  Iveskite nauja automobili:" << endl;
    cout << "  Automobilio markes pavadinimas  : ";  mark     = readNonEmptyLineFromCin();
    cout << "  Automobilio modelio pavadinimas : ";  model    = readNonEmptyLineFromCin();
    cout << "  Gamybos metai                : ";  cin >> year;
    cout << "  registracijos numeris  : ";  capacity = readNonEmptyLineFromCin();
    cout << "  Vietu skaicius automobile      : ";  cin >> seatsNr;
    cout << "  Dienos kainą               : ";  cin >> dayPrice;
    Autom autom = createAutom(automs.size(), mark, model, year, capacity, seatsNr, dayPrice, 0, 0, 0);
    automs.push_back(autom);
}
//----------------------------------------------------------------------
void addCustomer (Customers& customers)
{
    string  name;
    int age;
    int pCode;
    cout << "Iveskite nauja klienta:" << endl;
    cout << " vardas      : ";  name    = readNonEmptyLineFromCin();
    cout << " amzius      : ";  cin >> age;
    cout << " asmens kodas: ";  cin >> pCode;  
    
    Customer customer = createCustomer(customers.size(), name, age, pCode, 0);
    customers.push_back(customer);

}
//----------------------------------------------------------------------
int inputAutomId (const Automs& automs, AutomFilter automFilter)
{
    int count = printAutomsAndReturnCount(automs, automFilter);
    if (count == 0)
        return NULL_ID;
    while (true)
    {
        cout << "Iveskite automobilio Id (" << NULL_ID << " - nutraukti): ";
        int id = NULL_ID;
        cin  >> id;
        if (id == NULL_ID  ||  (id >= 0  &&  id < automs.size()))
            return id;
        cout << "KLAIDA: nera automobilio su ivestu Id." << endl;
    }
}
//----------------------------------------------------------------------
int inputCustomerId (const Customers& customers)
{
    int count = printCustomersAndReturnCount(customers);
    if (count == 0)
        return NULL_ID;
    while (true)
    {
        cout << "Iveskite kliento Id (" << NULL_ID << " - nutraukti): ";
        int id = NULL_ID;
        cin  >> id;
        if (id == NULL_ID  ||  (id >= 0  &&  id < customers.size()))
            return id;
        cout << "KLAIDA: nera kliento su ivestu Id." << endl;
    }
}
//----------------------------------------------------------------------
void rentAutom (Automs& automs, Customers& customers)
{
     int automId = inputAutomId(automs, AUTOM_FILTER_NOT_RENTED);
     if (automId == NULL_ID)
         return;
     if (isAutomRented(automs[automId]))
     {
         cout << "KLAIDA: automobilis jau yra isnuomotas.";
         return;
     }

     int customerId = inputCustomerId(customers);
     if (customerId == NULL_ID)
         return;

     int dayCount;
     cout << "Keliom dienom nuomuosime: ";
     cin  >> dayCount;

     double moneyEarned = rentAutomAndGetMoneyEarned(
         automs[automId], customers[customerId], dayCount);
     cout << "Iplaukos: " << moneyEarned << " Lt" << endl;
}
//----------------------------------------------------------------------
void returnBackAutom (Automs& automs)
{
     int automId = inputAutomId(automs, AUTOM_FILTER_RENTED);
     if (automId == NULL_ID)
         return;
     returnBackRentedAutom(automs[automId]);
}
//=====================================================================
void printRented (Automs& automs)
{
     int count;
     count = 0;
     for (int i = 0; i < automs.size(); i++)
     {
          Autom autom = automs[i];
          if (autom.rentedByCustomer > -1)
          {
               cout << "id="          << autom.id
               << "\tklientas="  << autom.rentedByCustomer
               << "\t"           << autom.dayPrice << "Lt"
               << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
               << "\t"           << autom.year
               << "\t"           << autom.mark
               << "\t"           << autom.model
               << endl;
               count++;
          }
     }
     if (count == 0)
          cout << "Isnuomuotu automobiliu sarasas yra tuscias!" << endl;
     return;
}
//=====================================================================
void printNotRented (Automs& automs)
{
     int count;
     count = 0;
     for (int i = 0; i < automs.size(); i++)
     {
          Autom autom = automs[i];
          if (autom.rentedByCustomer == -1)
          {
               cout << "id="     << autom.id
               << "\tklientas="  << autom.rentedByCustomer
               << "\t"           << autom.dayPrice << "Lt"
               << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
               << "\t"           << autom.year
               << "\t"           << autom.mark
               << "\t"           << autom.model
               << endl;
               count++;
          }
     }
     if (count == 0)
          cout << "Laisvu automobiliu sarasas yra tuscias!" << endl;
     return;
}
//=====================================================================
void moneyEarnedFromCustomer (Customers& customers,Automs& automs)
{    
     int count;
     count = 0;
     int customerId = inputCustomerId(customers);    
     if (customerId == NULL_ID)
          return;
     cout << "  -------- Klientas nuomoja siuos automobilius: ---------" << endl;
     for (int i = 0; i < automs.size(); i++)
     {
          Autom autom = automs[i];
          if (autom.rentedByCustomer == customerId)
          {
               cout << "id="     << autom.id
               << "\t"           << autom.dayPrice << "Lt"
               << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
               << "\t"           << autom.year
               << "\t"           << autom.mark
               << "\t"           << autom.model
               << endl;
               count++;
          }
     }
     if (count == 0)
          cout << "Sis klientas nenomuoja jokiu automobiliu!" << endl;
     return;
}

//=====================================================================
void mostRented (Automs& automs)
{
     int timesRented;
     int id;
     timesRented = NULL_ID;
     id   = NULL_ID;
     for (int i = 0; i < automs.size(); i++)
     {
          Autom autom = automs[i];
          if (autom.timesRented > timesRented)
          {
               timesRented = autom.timesRented;
               id          = i;
          }
     }
     if (id > NULL_ID)
     {
          Autom autom = automs[id];
          cout << " ----------- POPULIARIAUSIAS AUTOMOBILIS -------------------- " << endl << endl;
          cout << "id="     << autom.id
          << "\t"           << autom.dayPrice << "Lt"
          << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
          << "\t"           << autom.year
          << "\t"           << autom.mark
          << "\t"           << autom.model
          << endl;
     }
     else
         cout << "automobiliu sarasas yra tuscias";
     return;
}
//=====================================================================
void mostEarned (Automs& automs)
{
     int moneyEarned;
     int id;
     moneyEarned = 0;
     id   = 0;
     for (int i = 0; i < automs.size(); i++)
     {
          Autom autom = automs[i];
          if (autom.moneyEarned > moneyEarned)
          {
               moneyEarned = autom.moneyEarned;
               id          = i;
          }
     }
     if (id > NULL_ID)
     {
          Autom autom = automs[id];
          cout << " ----------- DAUGIAUSIAI UZDIRBES AUTOMOBILIS -------------------- " << endl << endl;
          cout << "id="     << autom.id
          << "\t"           << autom.dayPrice << "Lt"
          << "\t(uzdirbo="  << autom.moneyEarned << "Lt)"
          << "\t"           << autom.year
          << "\t"           << autom.mark
          << "\t"           << autom.model
          << endl;
     }
     else
          cout << "automobiliu sarasas yra tuscias";
     return;
}



